<?php
###############################################################################
# G5-Scripts.de PHP Guestbook Script v1.2.8
# Copyright 2004-2010 G5-Scripts.de webmaster@G5-Scripts.de
# Last Modified                24.01.2010
# G5-Scripts.de                http://www.G5-Scripts.de
################################################################################
# COPYRIGHT/Lizenz-/Nutzungs- Bestimmungen
# Copyright 2004-2010 G5-Scripts.de  All Rights Reserved.
#
# Durch den Download und Benutzung der Software erklrt sich der Benutzer mit
# den AGBs und diesem Lizenzabkommen von G5-Scripts.de einverstanden.
# Diese Software darf frei benutzt werden, solange dieser
# Copyrights Hinweis sowie alle Verweise auf G5-Scripts.de, eingebaut
# innerhalb der Software, erhalten bleiben!
# Die Original-Software unverndert darf weitergegeben, jedoch nicht verkauft
# oder wiederverkauft werden.
# Die angepasste bzw. vernderte Software und Teile dieser drfen nicht
# weitergegeben, verkauft oder wiederverkauft werden.
#
# Dieses Lizenzabkommen beruht sich auf der aktuellen internationalen Gesetzeslage.
#
# Bei einem Versto gegen dieses Lizenzabkommen macht sich der Benutzer strafbar
# und kann rechtlich verfolgt werden.
#
################################################################################

class GBEntity
{
    private $entityPath;
    private $commentPath;
    private $doc;

    public $id;
    public $datum;
    public $zeit;
    public $status=1;
    public $ip="";
    public $name="";
    public $vorname="";
    public $land="";
    public $email="";
    public $homepage="";
    public $message="";
    public $comment="";
    
    public function __construct($entityPath, $commentPath, $id)
    {
		$id = (int)$id;
        $this->doc = new DOMDocument('1.0', 'UTF-8');
        $this->doc->formatOutput = true; 
        $this->doc->appendChild($this->doc->createElement('Eintrag'));

        $this->id = $id;
        $this->entityPath = $entityPath."/".$this->id.".php";
        $this->commentPath = $commentPath."/".$this->id.".php";

        $this->datum = date("d.m.Y", $id);
		$this->zeit  = date("H:i", $id);
    }
    
    public function Load()
    {
        $entityFile = $this->entityPath;
        $commentFile = $this->commentPath;

        if(file_exists($entityFile)){
            @$ret = $this->doc->load($entityFile);
            
            if($ret){
                //ist XML

                $this->status   =$this->getValue("Status");
                $this->ip       =$this->getValue("IP");
                $this->name     =$this->getValue("Name");
                $this->vorname  =$this->getValue("Vorname");
                $this->land     =$this->getValue("Land");
                $this->email    =$this->getValue("Email");
                $this->homepage =$this->getValue("Homepage");
                $this->message  =$this->getValue("Message");

                if(file_exists($commentFile)){
                    $this->comment      =trim(implode("",file($commentFile)));
                }
                
                return true;
            }else{
                //hat nicht geklappt, scheint noch altes format zu sein
                $eintrag        = file($entityFile);
                
                $this->status   =1;
                $this->ip       =$eintrag[0];
                $this->name     =$eintrag[1];
                $this->vorname  =$eintrag[2];
                $this->land     =$eintrag[3];
                $this->email    =$eintrag[4];
                $this->homepage =$eintrag[5];
                $this->message  =implode("",array_slice($eintrag,6,count($eintrag)));

                if(file_exists($commentFile)){
                    $this->comment      =trim(implode("",file($commentFile)));
                }

                return true;
            }
        }
        
        return false;
    }
    
    public function Save()
    {
        $entityFile = $this->entityPath;
        $commentFile = $this->commentPath;
        
        $url = $this->homepage;
        $url= eregi_replace("http://", "", $url);
        $url= "http://".$url;
        
        $this->setValue("IP",      $this->ip);
        $this->setValue("Status",  $this->status);
        $this->setValue("Name",    $this->name);
        $this->setValue("Vorname", $this->vorname);
        $this->setValue("Land",    $this->land);
        $this->setValue("Email",   $this->email);
        $this->setValue("Homepage",$url);
        $this->setValue("Message", $this->message);

        $this->doc->save($entityFile);
    }
    
    private function getValue($tagName){
        $val = "";
        $node = $this->doc->getElementsByTagName($tagName)->item(0);
        if($node != null){
            $val = $node->nodeValue;
            $val = utf8_decode($val);
        }
        return $val;
    }
    
    private function setValue($tagName, $value){
        $root = $this->doc->getElementsByTagName("Eintrag")->item(0);
        $node = $this->doc->getElementsByTagName($tagName)->item(0);
        $value = trim($value, "\n");
        $value = trim($value, "\r");
        $value = trim($value, "\t");
        $value = utf8_encode($value);
        $value = $this->doc->createCDATASection($value);
		
        if($node != null){
			$root->removeChild($node);
		}
            
        $newNode = $this->doc->createElement($tagName);
        $newNode->appendChild($value);
        
        $root->appendChild($newNode);
    }
}

?>